-- MySQL dump 10.13  Distrib 5.5.24, for Win32 (x86)
--
-- Host: localhost    Database: mydb
-- ------------------------------------------------------
-- Server version	5.5.24

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `employee`
--

DROP TABLE IF EXISTS `employee`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `employee` (
  `empno` int(11) NOT NULL DEFAULT '0',
  `name` varchar(20) DEFAULT NULL,
  `dept` varchar(20) DEFAULT NULL,
  `salary` int(11) DEFAULT NULL,
  PRIMARY KEY (`empno`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `employee`
--

LOCK TABLES `employee` WRITE;
/*!40000 ALTER TABLE `employee` DISABLE KEYS */;
INSERT INTO `employee` VALUES (1,'Rakesh','Sales',34000),(2,'Aman','it',26000),(3,'Amber','it',32000),(4,'Rachit','sales',92000),(5,'sanskar','it',89000),(6,'pankhudi','it',95000),(7,'Chitransh','it',95000),(8,'Sunita','sales',95000),(9,'Priya','sales',73000),(10,'Piyush','it',173000),(11,'Sarthak','HR',153000);
/*!40000 ALTER TABLE `employee` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `interview`
--

DROP TABLE IF EXISTS `interview`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `interview` (
  `S_NO` int(11) NOT NULL,
  `NAME` varchar(20) DEFAULT NULL,
  `QUALIFICATION` varchar(20) DEFAULT NULL,
  `PHONE_NO` varchar(10) DEFAULT NULL,
  `FATHER` varchar(30) DEFAULT NULL,
  `ADDRESS` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`S_NO`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `interview`
--

LOCK TABLES `interview` WRITE;
/*!40000 ALTER TABLE `interview` DISABLE KEYS */;
INSERT INTO `interview` VALUES (1,'DIVYA GUPTA','M.TECH','8897465588','MOHIT GUPTA','19/129 MALL ROAD,KANPUR'),(2,'PRAGATI SINGH','B.SC','9878856655','MAHESH SINGH','2/543 RAWATPUR,KANPUR'),(3,'SARA ALI KHAN','B.PHARMA','7889545669','SAIF ALI KHAN','11/190 BIRHANA ROAD,KANPUR'),(4,'RANVEER SINGH','BCA','6307489513','RANJEET SINGH','30/147 BLOCK-57 ,KANPUR'),(5,'VIRAT KOHLI','MCA','9685888768','GURMEET KOHLI','2/503 BLOCK-32 ,NEW DELHI');
/*!40000 ALTER TABLE `interview` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `students`
--

DROP TABLE IF EXISTS `students`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `students` (
  `NAME` varchar(20) DEFAULT NULL,
  `ROLL_NO` int(11) NOT NULL DEFAULT '0',
  `STREAM` varchar(20) DEFAULT NULL,
  `PHONE_NO` varchar(10) DEFAULT NULL,
  `FATHER` varchar(30) DEFAULT NULL,
  `ADMISSION_NUM` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`ROLL_NO`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `students`
--

LOCK TABLES `students` WRITE;
/*!40000 ALTER TABLE `students` DISABLE KEYS */;
INSERT INTO `students` VALUES ('RAMAN',1,'SCIENCE','7523698541','RAMLAL','3652048265'),('RATI',2,'SCIENCE','9315843620','AKASH','8654923561'),('RASHI',3,'ARTS','6321086325','GOPAL','7569803210'),('AMAN',4,'ARTS','8695032165','RAMAN','8539854659'),('GAURAVE',5,'SCIENCE','6487503125','GOVIND','9521364598'),('HARSH',6,'SCIENCE','6598743569','ASHISH','7539874589'),('RUCHI',7,'SCIENCE','8539526485','SUNEEL','1365209548'),('RAMAN',8,'SCIENCE','8536546598','TARUN','3650326584'),('FAIQ',9,'ARTS','9036546598','SALMAN','3653326584'),('RIYA',10,'SCIENCE','9036036598','MOHAN','5853326584'),('DIVYANSH',11,'ARTS','9096403598','HARSH','5003326584'),('DAKSH',12,'SCIENCE','6906036598','ASHISH','5853303204');
/*!40000 ALTER TABLE `students` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2020-01-08 18:01:03
